Program PerceptronDemo;
uses PerceptronCore;
const
  LearningPatternNum = 16;
var
  LearningPattern : array[1..LearningPatternNum] of pattern;
  PatternNum : integer;
  indch : array[boolean] of char;
  s : string;

procedure SetUpDemoData;
begin
(*  1 - 1 and 2
	2 - 1 or 2
	3 - not (1 and 2)
	4 - not (1 or 2)
	5 - 1
	6 - 2
	7 - 1 xor 2
*)
  PatternNum := 4;
  SLayerCellNum := 2;
  RLayerCellNum := 7;
  with LearningPattern[1] do begin
	vec := [1, 2]; typ := [1, 2,       5, 6]
  end;
  with LearningPattern[2] do begin
	vec := [1   ]; typ := [   2, 3,    5,    7]
  end;
  with LearningPattern[3] do begin
	vec := [   2]; typ := [   2, 3,       6, 7]
  end;
  with LearningPattern[4] do begin
	vec := [];     typ := [      3, 4]
  end
end;

procedure LoadLearningPattern(fn : string);
var
  t : text;
  i, j, k : integer;

(*
SLayerCellNum(=size of each pattern vector) RLayerCellNum[EOLN]
PatternNum[EOLN]
[EOLN]
(SLayerCellNum of 0s or 1s, separated with a white space or EOLN)[EOLN]
(RLayerCellNum of 0s or 1s, separated with a white spece)[EOLN]
( repeat PatternNum times )
*)

begin
  assign(t, fn);
  reset(t);
  readln(t, SLayerCellNum, RLayerCellNum);
  readln(t, PatternNum);
  for i := 1 to PatternNum do begin
	readln(t);
	with LearningPattern[i] do begin
	  vec := [];
	  for j := 1 to SLayerCellNum do begin
		read(t, k);
		if k = 1 then include(vec, j)
	  end;
	  typ := [];
	  for j := 1 to RLayerCellNum do begin
		read(t, k);
		if k = 1 then include(typ, j)
	  end
	end
  end;
  close(t)
end;

procedure DispVector(v : InOutVector; vecsize, colnum : integer);
var i, j : integer;
begin
  j := 1;
  for i := 1 to vecsize do begin
	write(indch[i in v]);
	if j < colnum then inc(j)
				  else begin writeln; j := 1 end
  end
end;

procedure Teach;
var
  i, j, n : integer;
  r : ResultVector;
begin
  for i := 1 to 200 do begin
	n := succ(random(PatternNum));
	writeln; write(i, ' ', n, ' ');
	TeachAPatternWithResult(LearningPattern[n], r);
	for j := 1 to RLayerCellNum do write(' ', r[j])
  end;
  writeln
end;

procedure Trial;
var
  v : InOutVector;
  i, k : integer;
begin
  v := [];
  for i := 1 to SLayerCellNum do begin
	read(k);
	if eoln then readln;
	if k = 1 then include(v, i)
  end;
  SetInputVector(v);
  Calc;
  GetOutputVector(v);
  DispVector(v, RLayerCellNum, 5);
  writeln
end;

procedure DispWeights;
var i, n : integer;

  procedure SpyStatus(isR : boolean; n : integer);
  var p : pRegularCell;
	  i : integer;
	  e, t : single;
	  sc : ConnexionVector;
	  cn : integer;
  begin
	p := PeepCell(isR, n);
	if p <> nil then begin
	  p^.SpyStatus(e, t, sc, cn);
	  writeln('Em:', e, ' Threshold:', t, ' Fire:', p^.firing);
	  for i := 1 to cn do
		with sc[i] do writeln(i, ' ', from^.firing, ' ', weight)
	end else
	  writeln('cell not found.')
  end;

begin
  for n := 1 to PatternNum do begin
	writeln('Pattern No.', n);
	SetInputVector(LearningPattern[n].vec);
	Calc;
	writeln('Association Layer');
	for i := 1 to ALayerCellNum do begin
	  writeln('Cell No.', i);
	  SpyStatus(false, i)
	end;
	writeln('Reponse Layer');
	for i := 1 to RLayerCellNum do begin
	  writeln('Cell No.', i, ' ',
			  'Correct Answer ', i in LearningPattern[n].typ);
	  SpyStatus(true, i)
	end
  end
end;

begin
  write('Learning Pattern File ='); readln(s);
  if s = '' then SetUpDemoData
			else LoadLearningPattern(s);
  indch[false] := '_';
  indch[true] := '*';
  randomize;
  SetUpSLayer([]);
  write('Number of A cells (0 - Basic Perceptron) = ');
  readln(ALayerCellNum);
  SetUpALayer;
  SetUpRLayer;
  Teach;
  if s <> '' then
	repeat
	  writeln('Enter Test vector');
	  Trial;
	  write('Continue ? y/n= '); readln(s);
	until upcase(s[1]) = 'N';
  write('Dump Weight? y/n= '); readln(s);
  if upcase(s[1]) = 'Y' then DispWeights
end.
