unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Menus, StdCtrls, Buttons, Spin, math, PerceptronCore, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    ALayerCellNumComboBox: TComboBox;
    AbountMenuItem: TMenuItem;
    EpsilonEdit: TEdit;
    ColNumEdit: TEdit;
    CurrentIterLabel: TLabel;
    CurrentStatusLabel: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LearnPushButton: TButton;
    CalcPushButton: TButton;
    OutToInButton: TButton;
    MainMenu1: TMainMenu;
    FileMenuItem: TMenuItem;
    FileLoadPatternItem: TMenuItem;
    FileNewItem: TMenuItem;
    FileQuitItem: TMenuItem;
    FileIntoOutMenuItem: TMenuItem;
    FileDumpWeightsMenuItem: TMenuItem;
    IntervalSpinEdit: TSpinEdit;
    LearnIterSpinEdit: TSpinEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    TimeCoursePaintBox: TPaintBox;
    SLayerPaintBox: TPaintBox;
    RLayerPaintBox: TPaintBox;
    AdditionalPaintBox: TPaintBox;
    Timer1: TTimer;
    procedure AbountMenuItemClick(Sender: TObject);
    procedure AdditionalPaintBoxPaint(Sender: TObject);
    procedure CalcPushButtonClick(Sender: TObject);
    procedure FileDumpWeightsMenuItemClick(Sender: TObject);
    procedure FileIntoOutMenuItemClick(Sender: TObject);
    procedure FileLoadPatternItemClick(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure FileQuitItemClick(Sender: TObject);
    procedure IntervalSpinEditChange(Sender: TObject);
    procedure LearnPushButtonClick(Sender: TObject);
    procedure OutToInButtonClick(Sender: TObject);
    procedure SLayerPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RLayerPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SLayerPaintBoxPaint(Sender: TObject);
    procedure RLayerPaintBoxPaint(Sender: TObject);
    procedure StaticText1Click(Sender: TObject);
    procedure TimeCoursePaintBoxPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    CurrentVector,
    OutputVector : InOutVector;
    CurrentError : ResultVector;
    CurrentIterNum,
    ncols : integer;
    ErrorRec : array[1..256] of integer;
    TimeCourseRec : array[1..256] of TPoint;
    SelectedRcell : integer;
    LearningNow : boolean;
    procedure InitLearningStatus;
    procedure DispCellNums;
    procedure TeachSkip;
    procedure AddErrorStat(var r : ResultVector; vecsize : integer);
    procedure Recursion;
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation
uses unit2;
const
  LearningPatternNum = 16;
  boxsize = 16;
  boxsizeminus1 = 15;
var
  LearningPattern : array[1..LearningPatternNum] of pattern;
  PatternNum : integer;
  PatternFileName : string;
  
function fnstr(i : integer) : string;
var s : string;
begin
  str(i, s);
  fnstr := s
end;

function fnval(s : string) : integer;
var i : integer;
    w : word;
begin
  val(s, i, w);
  if w = 0 then fnval := i
           else fnval := 0
end;

procedure SetUpDemoData;
begin
(*  1 - 1 and 2
	2 - 1 or 2
	3 - not (1 and 2)
	4 - not (1 or 2)
	5 - 1
	6 - 2
	7 - 1 xor 2
*)
  PatternNum := 4;
  SLayerCellNum := 2;
  RLayerCellNum := 7;
  with LearningPattern[1] do begin
    vec := [1, 2]; typ := [1, 2,       5, 6]
  end;
  with LearningPattern[2] do begin
    vec := [1   ]; typ := [   2, 3,    5,    7]
  end;
  with LearningPattern[3] do begin
    vec := [   2]; typ := [   2, 3,       6, 7]
  end;
  with LearningPattern[4] do begin
    vec := [];     typ := [      3, 4]
  end
end;

procedure LoadLearningPattern(fn : string);
var
  t : text;
  i, j, k : integer;

(*
SLayerCellNum(=size of each pattern vector) RLayerCellNum[EOLN]
PatternNum[EOLN]
[EOLN]
(SLayerCellNum of 0s or 1s, separated with a white space or EOLN)[EOLN]
(RLayerCellNum of 0s or 1s, separated with a white spece)[EOLN]
( repeat PatternNum times )
*)

begin
  assign(t, fn);
  reset(t);
  readln(t, SLayerCellNum, RLayerCellNum);
  readln(t, PatternNum);
  for i := 1 to PatternNum do begin
    readln(t);
    with LearningPattern[i] do begin
      vec := [];
      for j := 1 to SLayerCellNum do begin
        read(t, k);
	if k = 1 then include(vec, j)
      end;
      typ := [];
      for j := 1 to RLayerCellNum do begin
        read(t, k);
	if k = 1 then include(typ, j)
      end
    end
  end;
  close(t)
end;

function ReadLearningPatternColumnNum(fn : string) : integer;
var
  t : text;
  i : integer;
  dummy : single;

(*
SLayerCellNum(=size of each pattern vector) RLayerCellNum[EOLN]
PatternNum[EOLN]
[EOLN]
(SLayerCellNum of 0s or 1s, separated with a white space or EOLN)[EOLN]
(RLayerCellNum of 0s or 1s, separated with a white spece)[EOLN]
( repeat PatternNum times )
*)

begin
  assign(t, fn);
  reset(t);
  readln(t); {SLayerCellNum, RLayerCellNum}
  readln(t); {PatternNum}
  readln(t);
  i := 0;
  while not (eoln(t) or eof(t)) do begin
    read(t, dummy);
    inc(i)
  end;
  close(t);
  ReadLearningPatternColumnNum := i
end;

procedure DumpWeights(fn : string);
var i, j : integer;
    pc   : pRegularCell;
    e, th: single;
    sc   : ConnexionVector;
    cn   : integer;
    t    : text;
begin
  assign(t, fn);
  rewrite(t);
  writeln(t, 'Association Layer');
  for i := 1 to ALayerCellNum do begin
    pc := PeepCell(false, i);
    pc^.SpyStatus(e, th, sc, cn);
    writeln(t, 'Cell Number : ', i, ' threshold : ', th);
    for j := 1 to cn do
      with sc[j] do writeln(t, 'From : ', from^.getTag, ' Weight : ', weight)
  end;
  writeln(t, 'Response Layer');
   for i := 1 to RLayerCellNum do begin
    pc := PeepCell(true, i);
    pc^.SpyStatus(e, th, sc, cn);
    writeln(t, 'Cell Number : ', i, ' threshold : ', th);
    for j := 1 to cn do
      with sc[j] do writeln(t, 'From : ', from^.getTag, ' Weight : ', weight)
  end;
  close(t)
end;

procedure DispVector(var cvs : TCanvas; w, h : integer;
                         v : InOutVector; vecsize, colnum : integer);
var i, x, y : integer;
begin
  with cvs do begin
    Brush.Color := $00FFFFFF;
    FillRect(0, 0, pred(w), pred(h));
{    ShowMessage(fnstr(w));}
    Brush.Color := $00000000
  end;
  for i := 1 to vecsize do
    if i in v then begin
      x := (pred(i) mod colnum) * boxsize;
      y := (pred(i) div colnum) * boxsize;
      cvs.FillRect(x, y, x + boxsizeminus1, y + boxsizeminus1)
    end
end;

procedure DispResponse(var cvs : TCanvas; w, h : integer;
                    vr : ResultVector; v : InOutVector; vecsize, colnum : integer);
var i, x, y : integer;
begin
  DispVector(cvs, w, h, v, vecsize, colnum);
  cvs.Brush.Style := bsClear;
  for i := 1 to vecsize do
    if vr[i] <> 0 then begin
      x := (pred(i) mod colnum) * boxsize;
      y := (pred(i) div colnum) * boxsize;
      if vr[i] > 0 then cvs.Pen.Color := $000000FF  (* red *)
                   else cvs.Pen.Color := $00FF0000; (* blue *)
      cvs.Rectangle(x, y, x + boxsizeminus1, y + boxsizeminus1)
    end;
  cvs.Brush.Style := bsSolid
end;

procedure DispSelectedCell(var cvs : TCanvas; colnum, sel : integer);
var i, x, y : integer;
begin
  x := (pred(sel) mod colnum) * boxsize;
  y := (pred(sel) div colnum) * boxsize;
  cvs.Pen.Color := $0000FF00;  (* green *)
  cvs.line(x, y, x + boxsizeminus1, y + boxsizeminus1);
  cvs.line(x, y + boxsizeminus1, x + boxsizeminus1, y)
end;

function HSVtoRGB(H, S, V : single) : longint;
(*
H (hue) is in degree, i.e. 0-360, pure red is 0, pure green is 120,
pure blue is 240.
S (saturation) ranges 0 - 1. 1 means very thick colour.
V (value) ranged 0 - 1. 0 means black.
Refer HSVtoRGBtest.pas for Java source.

in this function, R, G and B are mapped 0-255

*)
var i : integer;
    f, p1, p2, p3, rr, rg, rb : single;
    R, G, B : byte;
begin
  R := 0; G := 0; B := 0;
  if      S < 0 then S := 0
  else if S > 1 then S := 1;
  if      V < 0 then V := 0
  else if V > 1 then V := 1;
  while H >= 360 do H := H - 360;
  while H < 0 do H := H + 360;
  H := H / 60;
  i := floor(H);
  f := H - i;
  p1 := V * (1 - S);
  p2 := V * (1 - S * f);
  p3 := V * (1 - S * (1 - f));
  case i of
    0 : begin rr := V;  rg := p3; rb := p1 end;
    1 : begin rr := p2; rg := V;  rb := p1 end;
    2 : begin rr := p1; rg := V;  rb := p3 end;
    3 : begin rr := p1; rg := p2; rb := V  end;
    4 : begin rr := p3; rg := p1; rb := V  end;
    5 : begin rr := V;  rg := p1; rb := p2 end
  end;
  R := round(rr * 255);
  G := round(rg * 255);
  B := round(rb * 255);
  HSVtoRGB := B shl 16 or G shl 8 or R
end;


{ TForm1 }

procedure TForm1.DispCellNums;
begin
  CurrentStatusLabel.Caption :=  'S: ' + fnstr(SLayerCellNum) +
                    ' A: ' + fnstr(ALayerCellNum) +
                    ' R: ' + fnstr(RLayerCellNum) +
                    ' Pattern: ' + fnstr(PatternNum)
end;

procedure TForm1.FileLoadPatternItemClick(Sender: TObject);
begin
  InitLearningStatus;
  OpenDialog1.Execute;
  PatternFileName := OpenDialog1.FileName;
  if PatternFileName = '' then begin
    SetUpDemoData;
    ColNumEdit.Text := fnstr(RLayerCellNum)
  end else begin
    LoadLearningPattern(PatternFileName);
    ColNumEdit.Text := fnstr(ReadLearningPatternColumnNum(PatternFileName))
  end;
  DispCellNums;
  CurrentVector := LearningPattern[1].vec;
  ncols := fnval(ColNumEdit.Text);
  SLayerPaintBox.invalidate {refresh}
end;

procedure TForm1.FileNewItemClick(Sender: TObject);
begin
  DestroyLayers;
  InitLearningStatus;
  CurrentStatusLabel.Caption := 'No network constructed';
  invalidate
end;

procedure TForm1.FileQuitItemClick(Sender: TObject);
begin
  close
end;

procedure TForm1.InitLearningStatus;
begin
  Timer1.Enabled := false;
  LearningNow := false;
  LearnPushButton.Caption := 'Learn';
  CurrentIterNum := 0;
  CurrentIterLabel.Caption := fnstr(CurrentIterNum);
  fillchar(ErrorRec, sizeof(ErrorRec), 0);
  SelectedRcell := 0; (* no cell is selected *)
end;

procedure TForm1.IntervalSpinEditChange(Sender: TObject);
begin
  Timer1.Interval := fnval(IntervalSpinEdit.text)
end;

procedure TForm1.CalcPushButtonClick(Sender: TObject);
begin
  SetInputVector(CurrentVector);
  Calc;
  GetOutputVector(OutPutVector);
  AdditionalPaintBox.invalidate; {refresh}
  RLayerPaintBox.invalidate {refresh}
end;

procedure TForm1.FileDumpWeightsMenuItemClick(Sender: TObject);
var fn : string;
begin
  SaveDialog1.Execute;
  fn := SaveDialog1.FileName;
  if fn <> '' then DumpWeights(fn)
end;

procedure TForm1.AdditionalPaintBoxPaint(Sender: TObject);
const
  colnum = 32;
var
  i, j, x, y, boxsize : integer;
  pc : pRegularcell;
  e, t : single;
  sc : ConnexionVector;
  cn : integer;
begin
  with AdditionalPaintBox.Canvas do begin
    Brush.Color := $00FFFFFF;
    FillRect(0, 0, pred(width), pred(height));
    Brush.Color := $00000000;
    boxsize := width div (succ(colnum))
  end;
  for j := 1 to ALayerCellNum do begin
    pc := PeepCell(false, j);
    if pc^.firing then begin
      i := pc^.getTag;
      x := (pred(i) mod colnum) * boxsize;
      y := (pred(i) div colnum) * boxsize;
      AdditionalPaintBox.Canvas.FillRect(x, y, x + pred(boxsize), y + pred(boxsize))
    end
  end;
  if SelectedRcell <> 0 then begin
    AdditionalPaintBox.Canvas.Brush.Style := bsClear;
    pc := PeepCell(true, SelectedRcell);
    pc^.SpyStatus(e, t, sc, cn);
    for j := 1 to cn do
      with sc[j] do begin
        i := from^.getTag;
        x := (pred(i) mod colnum) * boxsize;
        y := (pred(i) div colnum) * boxsize;
        AdditionalPaintBox.Canvas.Pen.color := HSVtoRGB(180 * weight, 1, 1);
        AdditionalPaintBox.Canvas.Rectangle(x, y, x + pred(boxsize), y + pred(boxsize))
      end;
    AdditionalPaintBox.Canvas.Brush.Style := bsSolid
  end
end;

procedure TForm1.AbountMenuItemClick(Sender: TObject);
begin
  Form2.Show
end;

procedure TForm1.FileIntoOutMenuItemClick(Sender: TObject);
begin
  Recursion
end;

procedure TForm1.LearnPushButtonClick(Sender: TObject);
var s : string;
    e : single;
    i : integer;
begin
  if not LearningNow then begin
    Timer1.Enabled := false;
    if CurrentIterNum = 0 then begin
      SetUpSLayer([]);
      ALayerCellNum := fnval(ALayerCellNumComboBox.Text);
      SetUpALayer;
      SetUpRLayer;
      DispCellNums
    end;
    val(EpsilonEdit.Text, e, i);
    if i = 0 then epsilon := e;
    LearningNow := true;
    Timer1.Enabled := true;
    s := 'Stop'
  end else begin
    Timer1.Enabled := false;
    LearningNow := false;
    if CurrentIterNum = 0 then s := 'Learn'
                          else s := 'Restart'
  end;
  LearnPushButton.Caption := s
end;

procedure TForm1.OutToInButtonClick(Sender: TObject);
begin
  Recursion
end;

procedure TForm1.SLayerPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i, xx, yy : integer;
begin
  if Button = mbLeft then begin
    xx := x div boxsize;
    yy := y div boxsize;
    i := succ(yy * ncols + xx);
    if i in CurrentVector then exclude(CurrentVector, i)
                          else include(CurrentVector, i);
    SLayerPaintBox.invalidate {refresh}
  end
end;

procedure TForm1.RLayerPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i, xx, yy : integer;
begin
  if Button = mbLeft then begin
    xx := x div boxsize;
    yy := y div boxsize;
    i := succ(yy * ncols + xx);
    if i > RLayerCellNum then exit;
    if i = SelectedRcell then SelectedRcell := 0
                         else SelectedRcell := i;
    RLayerPaintBox.invalidate; {refresh}
    AdditionalPaintBox.invalidate {refresh}
  end
end;

procedure TForm1.SLayerPaintBoxPaint(Sender: TObject);
begin
  if SLayerCellNum > 0 then
    with SLayerPaintBox do
      DispVector(Canvas, width, height, CurrentVector, SLayerCellNum, ncols)
end;

procedure TForm1.RLayerPaintBoxPaint(Sender: TObject);
begin
  if RLayerCellNum > 0 then with RLayerPaintBox do begin
    if LearningNow then
      DispResponse(Canvas, width, height, CurrentError, OutputVector, RLayerCellNum, ncols)
    else
      DispVector(Canvas, width, height, OutputVector, RLayerCellNum, ncols);
    if SelectedRcell <> 0 then DispSelectedCell(Canvas, ncols, SelectedRcell)
  end
end;

procedure TForm1.StaticText1Click(Sender: TObject);
begin

end;

procedure TForm1.TimeCoursePaintBoxPaint(Sender: TObject);
begin
  TimeCoursePaintBox.Canvas.Pen.Color := $0000FFFF;
  TimeCoursePaintBox.Canvas.Polyline(@TimeCourseRec, CurrentIterNum)
end;

procedure TForm1.TeachSkip;
var n : integer;
begin
  n := succ(random(PatternNum));
  CurrentVector := LearningPattern[n].vec;
  TeachAPatternWithResult(LearningPattern[n], CurrentError);
  GetOutPutVector(OutputVector)
end;

procedure TForm1.AddErrorStat(var r : ResultVector; vecsize : integer);
var i, s : integer;
begin
  if CurrentIterNum <= 256 then begin
    s := 0;
    for i := 1 to vecsize do inc(s, abs(r[i]));
    ErrorRec[CurrentIterNum] := s;
    TimeCourseRec[CurrentIterNum].x := CurrentIterNum;
    TimeCourseRec[CurrentIterNum].y := 70 - s * 4
  end
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if CurrentIterNum < fnval(LearnIterSpinEdit.Text) then begin
    inc(CurrentIterNum);
    CurrentIterLabel.Caption := fnstr(CurrentIterNum);
    TeachSkip;
    SLayerPaintBox.invalidate; {refresh ?}
    RLayerPaintBox.invalidate;
    AddErrorStat(CurrentError, RLayerCellNum);
    TimeCoursePaintBox.invalidate;
    AdditionalPaintBox.invalidate
  end else begin
    Timer1.Enabled := false;
    LearningNow := false;
    LearnPushButton.Caption := 'Learn'
  end
end;

procedure TForm1.Recursion;
begin
  if SLayerCellNum = RLayerCellNum then begin
    CurrentVector := OutPutVector;
    SLayerPaintBox.invalidate {refresh}
  end else
    ShowMessage('Dimensions of Input and Output vectors are different.')
end;

initialization
  {$I unit1.lrs}
  randomize
end.

